#pragma once
#include "NeuralNetwork.h"
#define NOMINMAX
#include "windows.h"

struct TrailSegment {
    int x;
    int y;
    int age;    
};

class Beetle {
public:
    Beetle();
    void Move(/*std::vector<double>& inputs*/);
    void Draw(HDC hdc);
    Beetle Crossover(const Beetle& other, double crossoverRate, int type) const;
    void Mutate(double mutationRate);

    NeuralNetwork& GetNeuralNetwork();
    const NeuralNetwork& GetNeuralNetwork() const;

    // Getter fr ID
    int GetID() const { return id; }

    // Weitere Getter und Setter
    int GetX() const { return x; }
    int GetY() const { return y; }
    void SetCurrentGeneration(bool current) { isCurrentGeneration = current; }
    void SetFoodX(int x) { foodX = x; }
    void SetFoodY(int y) { foodY = y; }
    const int GetFoodX() { return foodX; };
    const int GetFoodY() { return foodY; };
    bool IsFoodFound() const { return foodFound; }
    void SetFoodFound(bool value) { foodFound = value; }
        
private:
    NeuralNetwork neuralNetwork;
    static int nextId; // Statische Variable zur Generierung eindeutiger IDs
    int id;
    int x;
    int y;
    int foodX;
    int foodY;
    bool foodFound;
    static bool foodMoved;
    std::vector<TrailSegment> trail;
    bool isCurrentGeneration;
};

