#pragma once

constexpr bool TEST_WITHOUT_NN = false;

extern int TotalHitsPerGeneration;
extern int FOOD_X;
extern int FOOD_Y;

constexpr int POPULATION_SIZE = 75;
constexpr int GENERATION_INTERVAL = 70; 

constexpr int WINDOW_WIDTH  = 1100;
constexpr int WINDOW_EXTRAWIDTH = 300;
constexpr int WINDOW_HEIGHT =  800;
constexpr int STATUS_HEIGHT =   70;

constexpr int FOOD_SHIFT_X = 500;
constexpr int FOOD_SHIFT_Y = 280;
constexpr int FOOD_SIZE = 8;
constexpr int BEETLE_SIZE = 5;
constexpr int FOOD_HIT = FOOD_SIZE;
constexpr int TRAIL_MAX_LENGTH = 100; // fr die Spur
constexpr int TRAIL_COLOR_PARAMETER1 = 235;
constexpr int FADING_FACTOR = 20;
constexpr double SPEED = 15;

constexpr int INPUT_SIZE = 1;
constexpr int OUTPUT_SIZE = 1;
constexpr int NUM_HIDDEN_LAYERS = 2;
constexpr int HIDDEN_LAYER_SIZE = 8;
constexpr bool RELU_FOR_HIDDEN = false; // ohne scheint es besser zu gehen
constexpr bool SIGMOID_FOR_OUTPUT = false; // bisher schwierig, wenn true (Skalierung?)!

constexpr int HEATMAP_SIZE = INPUT_SIZE * HIDDEN_LAYER_SIZE + 
NUM_HIDDEN_LAYERS * HIDDEN_LAYER_SIZE * HIDDEN_LAYER_SIZE + 
HIDDEN_LAYER_SIZE * OUTPUT_SIZE;
constexpr int CELL_SIZE = 20; // Die Gre jeder Zelle in der Heatmap
constexpr int HEATMAP_DIM_X = HEATMAP_SIZE / HIDDEN_LAYER_SIZE;
constexpr int HEATMAP_DIM_Y = HIDDEN_LAYER_SIZE;

constexpr double MUTATION_MIN = -0.1;
constexpr double MUTATION_MAX =  0.1;
constexpr int BEST_SELECTOR = 2; // Divisor 2 bedeutet 50% fr die Reproduktion

constexpr int CROSSOVER_TYPE = 2;
constexpr bool CLONING_FORBIDDEN = false;

constexpr COLORREF BLUE = RGB(0, 0, 255);
constexpr COLORREF RED = RGB(255, 0, 0);
constexpr COLORREF GREEN = RGB(0, 255, 0);
constexpr COLORREF WHITE = RGB(255, 255, 255);
constexpr COLORREF GRAY = RGB(128, 128, 128);
constexpr COLORREF LIGHTGRAY = RGB(211, 211, 211);

constexpr int STATUS_UPDATE_INTERVAL1 = 300;
constexpr int STATUS_UPDATE_INTERVAL2 = 3000;
constexpr int SLEEP_TIME = 0;



/*
Interessante Infos von der KI:

In meinem Fall "Kfer suchen Futter" sind die Generationen schneller erfolgreich, wenn ich nur eine hidden layer anstelle 2 verwende. Ist das bekannt oder logisch?

ChatGPT-4o:
Ja, das Verhalten, dass ein neuronales Netzwerk mit einer einzigen versteckten Schicht schneller erfolgreich ist als ein Netzwerk mit zwei versteckten Schichten, kann durchaus bekannt und logisch sein. Hier sind einige Grnde dafr:
1. Komplexitt und beranpassung
Einfacheres Netzwerk: Ein Netzwerk mit weniger Schichten und Neuronen ist einfacher und hat weniger Parameter zu optimieren. Das bedeutet, dass es schneller lernen kann, insbesondere wenn die Trainingsdaten oder die Aufgabe relativ einfach sind.
beranpassung: Mit mehr Schichten und Neuronen erhht sich die Gefahr der beranpassung (Overfitting), insbesondere wenn die Anzahl der Trainingsdaten begrenzt ist. 
Ein einfacheres Netzwerk generalisiert oft besser und findet schneller eine gute Lsung.
2. Rechenaufwand
Weniger Berechnungen: Weniger Schichten bedeuten weniger Berechnungen pro Vorwrts- und Rckwrtsdurchlauf (Feedforward und Backpropagation). Dies fhrt zu schnellerem Training, da die Berechnungen effizienter durchgefhrt werden knnen.
3. Datenverfgbarkeit
Datenmangel: Wenn die Anzahl der verfgbaren Trainingsdaten begrenzt ist, kann ein einfacheres Netzwerk besser und schneller lernen, da es weniger Parameter zu optimieren hat.
4. Optimierungsprobleme
Gradientenverlust: Bei tieferen Netzwerken kann das Problem des verschwindenden Gradienten (vanishing gradient problem) auftreten, wodurch das Training der unteren Schichten langsamer wird. 
Bei einer einzelnen versteckten Schicht tritt dieses Problem weniger hufig auf.
5. bertragung der Lsung
Einfache Aufgaben: Bei vielen Aufgaben reicht eine einzige versteckte Schicht oft aus, um die notwendigen Muster in den Daten zu lernen. Wenn die Aufgabe relativ einfach ist (z.B. ein Kfer sucht Futter), kann ein komplexeres Netzwerk unntig sein und das Training verlangsamen.
Fazit
Es ist nicht ungewhnlich, dass ein einfacheres Netzwerk (eine versteckte Schicht) schneller und effektiver lernen kann als ein komplexeres Netzwerk (zwei versteckte Schichten), insbesondere bei einfacheren Aufgaben und begrenzten Datenmengen. 
Es ist immer eine gute Praxis, die Architektur des neuronalen Netzwerks an die spezifische Aufgabe und die verfgbaren Daten anzupassen.

Weitere Schritte
Falls du experimentieren mchtest, knntest du verschiedene Netzwerkkonfigurationen ausprobieren und beobachten, wie sie sich auf die Leistung und die Trainingszeit auswirken. Hier sind einige Vorschlge:

Variiere die Anzahl der Neuronen in der versteckten Schicht.
Teste unterschiedliche Aktivierungsfunktionen.
Experimentiere mit verschiedenen Lernraten und Optimierungsalgorithmen.
Fhre Kreuzvalidierung durch, um die Generalisierungsfhigkeit zu testen.
Durch systematisches Testen und Optimieren kannst du die beste Netzwerkarchitektur fr deine spezifische Anwendung finden.

*/

