#pragma once
#include <vector>
#include "Beetle.h"

class GeneticAlgorithm {
public:
    std::pair<std::vector<Beetle>, std::pair<int, int>> NextGeneration(const std::vector<Beetle>& currentGeneration, double mutationRate, double crossoverRate);

    double CalculateAverageFitness(const std::vector<Beetle>& beetles);
    double GetMutationRate(double previousBestFitness, double currentBestFitness);
    double GetCrossoverRate(double previousAverageFitness, double currentAverageFitness);
};
