#pragma once
#include <vector>

class NeuralNetwork
{
public:
    NeuralNetwork(int inputSize, int outputSize, int numHiddenLayers, int hiddenLayerSize);
    std::vector<double> FeedForward(const std::vector<double>& inputs);
    std::vector<double> GetWeights() const;
    void SetWeights(const std::vector<double>& newWeights);
    double Sigmoid(double x);
    double ReLU(double x);

private:
    std::vector<std::vector<double>> weights;
    int inputSize;
    int outputSize;
    int numHiddenLayers;
    int hiddenLayerSize;

    void InitializeWeights();
};


